VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cICL"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'---------------------------------------------------------------------------------------
' Klasse    : cICL
' Datum     : 2.09.2003
' Autor     : G.Beckmann - Email:G.Beckmann@NikoCity.de
' Zweck     : Extraktion einzelner Icons aus ICL-Dateien
' Revision  : v2
'---------------------------------------------------------------------------------------

' Anmerkung des Autors:
' Mir ist der genaue Aufbau einer ICL-Datei nicht bekannt. Am Anfang einer ICL-Datei
' lassen sich RT_GROUP_ICON-Resourcen nebst GRPICONDIR und GRPICONDIRENTRY-Strukturen
' ausmachen. Ich bin bislang nicht dahinter gekommen, wie sich die genaue Position
' dieser Strukturen ausmachen lsst. Daher  durchsuche ich eine ICL-Datei einfach nach
' allen vorkommenden DIBs.


Option Explicit

'// API
Private Declare Sub RtlMoveMemory Lib "kernel32" (dst As Any, src As Any, ByVal cb&)
Private Declare Function CreateIconFromResourceEx& Lib "user32" (presbits As Any, ByVal dwResSize&, ByVal fIcon&, ByVal dwVer&, ByVal cxDesired&, ByVal cyDesired&, ByVal uFlags&)
Private Declare Function CreateIconFromResource& Lib "user32" (presbits As Any, ByVal dwResSize&, ByVal fIcon&, ByVal dwVer&)
Private Declare Function DestroyIcon Lib "user32" (ByVal hIcon As Long) As Long

Private Type GUID
  Data1    As Long
  Data2    As Integer
  Data3    As Integer
  Data4(8) As Byte
End Type

Private Type PICTDESC
  cbSize  As Long
  picType As Long
  hImage  As Long
  xExt    As Long
  yExt    As Long
End Type

Private Declare Function IIDFromString& Lib "ole32" (ByVal lpsz&, ByRef lpiid As GUID)
Private Declare Function OleCreatePictureIndirect& Lib "olepro32" (ByRef pPictDesc As PICTDESC, ByRef riid As GUID, ByVal fOwn&, ByRef ppvObj As IPicture)


'// Locals
Private m_abData()  As Byte ' Die ICL-Datei
Private m_aPosBIH() As Long ' Positionen der BitmapInfoHeader
Private m_nBIH      As Long ' Anzahl der BitmapInfoHeader


Public Enum EImageInfo
    ii_Width
    ii_Height
    ii_Colors
    ii_Planes
End Enum

Public Sub Load_icl(PathFileName$)
    Dim fn%, c&, biSizeImage&, f As Boolean, ub&, hIcon&
    
    '// Datei einlesen
    fn = FreeFile
    Open PathFileName For Binary Access Read As #fn
    ReDim m_abData(LOF(fn))
    Get #fn, , m_abData()
    Close #fn

    '// BitmapInfoHeader suchen
    m_nBIH = -1
    ReDim m_aPosBIH(100)
    ub = UBound(m_abData())
    For c = 0 To ub - 40
        If m_abData(c) = 40 Then                ' &H28
            If m_abData(c + 1) = 0 Then         ' &H00
                If m_abData(c + 2) = 0 Then     ' &H00
                    If m_abData(c + 3) = 0 Then ' &H00
    
                        '// Validieren
                        If f = False Then
                            hIcon = CreateIconFromResource(m_abData(c), ub - c, 1, &H30000)
                            If hIcon <> 0 Then f = True: DestroyIcon hIcon
                        End If
                        
                        If f Then
                            m_nBIH = m_nBIH + 1     ' Anzahl inkrementieren
                            m_aPosBIH(m_nBIH) = c   ' Position merken
                            
                            ' um die Icon-Gre berspringen
                            RtlMoveMemory biSizeImage, m_abData(c + 20), 4
                            c = c + biSizeImage + 40
                            
                            If m_nBIH = UBound(m_aPosBIH()) Then ReDim Preserve m_aPosBIH(m_nBIH + 100)
                            f = False
                        End If
                    End If
                End If
            End If
        End If
    Next c
End Sub

Public Sub Unload_icl()
    Erase m_abData()
    m_nBIH = -1
End Sub
    
Public Property Get IconCount() As Long
    IconCount = m_nBIH + 1
End Property
    
Public Function CreateIcon(ByVal index As Long) As Long
    Dim dx&, dy&, pos&
    If index < 0 Or index > m_nBIH Then Err.Raise 9
    pos = m_aPosBIH(index)
    RtlMoveMemory dx, m_abData(pos + 4), 4
    RtlMoveMemory dy, m_abData(pos + 8), 4
    CreateIcon = CreateIconFromResourceEx(m_abData(pos), UBound(m_abData()) - pos, 1, &H30000, dx, dy \ 2, 0)
End Function

Public Function CreateOleIcon(ByVal index As Long) As IPicture
    Const IPictureIID = "{7BF80981-BF32-101A-8BBB-00AA00300CAB}"
    Dim hIcon&, tGuid As GUID, tPD As PICTDESC

    hIcon = CreateIcon(index)
    
    If IIDFromString(StrPtr(IPictureIID), tGuid) = 0 Then
       With tPD
           .cbSize = Len(tPD)
           .hImage = hIcon
           .picType = PictureTypeConstants.vbPicTypeIcon
           OleCreatePictureIndirect tPD, tGuid, 1, CreateOleIcon
       End With
    End If
End Function

Public Function IconInfo(ByVal index As Long, ByVal info As EImageInfo) As Long
    Dim pos&
    If index < 0 Or index > m_nBIH Then Err.Raise 9
    pos = m_aPosBIH(index)
    Select Case info
    Case EImageInfo.ii_Width
        RtlMoveMemory IconInfo, m_abData(pos + 4), 4
    Case EImageInfo.ii_Height
        RtlMoveMemory IconInfo, m_abData(pos + 8), 4
        IconInfo = IconInfo \ 2
    Case EImageInfo.ii_Colors
        RtlMoveMemory IconInfo, m_abData(pos + 14), 2
        IconInfo = 2 ^ IconInfo
    Case EImageInfo.ii_Planes
        RtlMoveMemory IconInfo, m_abData(pos + 14), 2
    End Select
End Function

Private Sub Class_Initialize()
    m_nBIH = -1
End Sub
